; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "GnuPG Shell"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "Tech-Faq"
!define PRODUCT_WEB_SITE "http://www.tech-faq.com/gnupg-shell.shtml"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\wxGnuPGShell.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

SetCompressor /FINAL /SOLID lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"


; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "license.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "GnuPG Shell"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\wxGnuPGShell.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "Setup.exe"
InstallDir "$PROGRAMFILES\GnuPG Shell"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show


Section "Application Core" SEC01

; Code for checking for installed GnuPG
;------------------------------------------

"GnuPG-Test-Redo:"
ReadRegStr $0 HKLM Software\GNU\GnuPG "Install Directory"
StrCmp $0 "" "GnuPG-Test-Exit" "GnuPG-Test-Continue"

"GnuPG-Test-Exit:"
  MessageBox MB_OK "GnuPG not installed on your system. Please, install it first."
  ExecShell "open" "www.gnupg.org/download/"
  MessageBox MB_YESNO "Retry?" IDYES "GnuPG-Test-Redo" IDNO "GnuPG-Test-Abort"

"GnuPG-Test-Abort:"
  Abort "Aborting..."

"GnuPG-Test-Continue:"

  DetailPrint "GnuPG is installed at: $0"
;------------------------------------------

  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "..\bin\wxGnuPGShell.exe"
  SetOutPath "$INSTDIR\art"
  SetOverwrite try
  File "..\bin\art\file_manager.ico"
  File "..\bin\art\exit.ico"
  File "..\bin\art\doc_stop.ico"
  File "..\bin\art\about.ico"
  File "..\bin\art\pen_yellow.ico"
  File "..\bin\art\doc_add.ico"
  File "..\bin\art\public.ico"
  File "..\bin\art\encrypt.ico"
  File "..\bin\art\secret.ico"
  File "..\bin\art\retreive.ico"
  File "..\bin\art\email.ico"
  File "..\bin\art\add.ico"
  File "..\bin\art\send.ico"
  File "..\bin\art\refresh.ico"
  File "..\bin\art\settings.ico"
  File "..\bin\art\sign.ico"
  File "..\bin\art\pen_green.ico"
  File "..\bin\art\delete.ico"
  File "..\bin\art\warning.ico"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\GnuPG Shell.lnk" "$INSTDIR\wxGnuPGShell.exe"
  CreateShortCut "$DESKTOP\GnuPG Shell.lnk" "$INSTDIR\wxGnuPGShell.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\wxGnuPGShell.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\wxGnuPGShell.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP

  DeleteRegKey HKCU "Software\wxGnuPGShell"

  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\art\warning.ico"
  Delete "$INSTDIR\art\delete.ico"
  Delete "$INSTDIR\art\pen_green.ico"
  Delete "$INSTDIR\art\sign.ico"
  Delete "$INSTDIR\art\settings.ico"
  Delete "$INSTDIR\art\refresh.ico"
  Delete "$INSTDIR\art\send.ico"
  Delete "$INSTDIR\art\add.ico"
  Delete "$INSTDIR\art\email.ico"
  Delete "$INSTDIR\art\retreive.ico"
  Delete "$INSTDIR\art\secret.ico"
  Delete "$INSTDIR\art\encrypt.ico"
  Delete "$INSTDIR\art\public.ico"
  Delete "$INSTDIR\art\doc_add.ico"
  Delete "$INSTDIR\art\pen_yellow.ico"
  Delete "$INSTDIR\art\about.ico"
  Delete "$INSTDIR\art\doc_stop.ico"
  Delete "$INSTDIR\art\exit.ico"
  Delete "$INSTDIR\art\file_manager.ico"
  Delete "$INSTDIR\wxGnuPGShell.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$DESKTOP\GnuPG Shell.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\GnuPG Shell.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\art"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd